#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pixelscale.h"
#include "readraw.h"
#include "time.h"

void GetPixel( unsigned char *whence , unsigned char *pixel )
{	*pixel++ = *whence++;
	*pixel++ = *whence++;
	*pixel++ = *whence++;
}

static inline void PutPixel( unsigned char *address, unsigned char *pixel )
{	*address++ = *pixel++;
	*address++ = *pixel++;
	*address++ = *pixel++;
	//memcpy( address, pixel, 3 );
}

int main( int argc, char** argv )
{	double par = 1.2;
	ps_format_in  fmt_in;	
	ps_format_out fmt_out;
	ps_size       size_in, size_out;
	ps_pixels     pix_in, pix_out;
	ps_rect       rect;
	int i;

	fmt_out.put_pixel = NULL; //&PutPixel;
	fmt_out.bpp  = 3;
	fmt_out.step = 3;

	fmt_in .get_pixel = NULL; //&GetPixel;
	fmt_in .bpp  = 3;
	fmt_in .step = 3;

	time_t start,end;

	size_in.h = 400;
	size_in.w = 640;
	pix_in.pitch  = size_in.w * fmt_in.step;

	size_out.h = 2000; 
	size_out.w = 2560;

	pix_out.pitch  = size_out.w * fmt_out.step;
	pix_out.pixels = (unsigned char*)malloc( size_out.h * pix_out.pitch );

	const char* PATH = "rawtest.data";
	const char* PATH_OUT = "rawout.data";
	ReadRaw( PATH, size_in.w, size_in.h, (char**)&pix_in.pixels );
	ps_size size_ps = size_out;

	char dw = 0, dh = 0;
	ps_info si = ps_new_perfect( fmt_in, size_in, fmt_out, size_out, dw, dh, 3, par, &size_ps );
	//ps_info si = ps_new_soft   ( fmt_in, size_in, fmt_out, size_out, dw, dh, 3, 1.0 );
	//ps_info si = ps_new_nn( fmt_in, size_in, fmt_out, size_out, dw, dh, 3 );
	rect.x = 0; rect.y = 0; rect.w = size_in.w; rect.h = size_in.h;
	start = clock();
	ps_rect rect_lp;
	for( i = 0; i < 128; i++ )
	{	rect_lp = rect;
		ps_scale( si, pix_in, pix_out, &rect_lp );
	}
	//printf("rect_old: x=%3i, y=%3i, w=%3i, h=%3i\n", rect   .x, rect.   y, rect   .w, rect   .h);
	//printf("rect_new: x=%3i, y=%3i, w=%3i, h=%3i\n", rect_lp.x, rect_lp.y, rect_lp.w, rect_lp.h);
	end = clock();
	printf("Total seconds: %4.2f\n", (double)(end-start)/CLOCKS_PER_SEC);
	ps_free( si );
	WriteRaw( (char*)pix_out.pixels, size_out.w, size_out.h, PATH_OUT );
	FreeRaw( (char*)pix_in .pixels  );
	FreeRaw( (char*)pix_out.pixels );

	return 0;
}
